import { Button, Descriptions,Popconfirm, Row, Col, Form,Modal, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule,setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import stylesStep from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from "antd/lib/index";
import FormPage from '../../../components/FormPage'
class PR050ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            BtnAgreeDisplay: 'none',
            tmpData: {},
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'PR/PRDrugUseRecord/IdentityUpdate',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined"&&typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let that=this;
        let json = initFilter(that.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendInclude(json, 'Nav_Department');
        extendInclude(json, 'Nav_Users.Nav_User.Nav_UserSignFiles.Nav_ImgFile.Nav_File');
        extendInclude(json, 'Nav_Drug');
        extendInclude(json, 'Nav_Type');
        extendInclude(json, 'Nav_Specify');
        extendInclude(json, 'Nav_Confirms');
        extendIgnoreDataRule(json)
       that.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'PR/DrugUseRecord/Get',
            onComplete: (ret) => {
                if (ret) {
                    if(that.props.data && that.props.data.loadDataDeal)
                    {
                        that.props.data.loadDataDeal(1);
                    }
                    that.setState({ data: ret });
                    if (that.props.data.tableKey==="2" ||that.props.data.tableKey===undefined) {
                        that.setState({ BtnAgreeDisplay: 'none' })
                    }else{
                        that.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    this.onClickApprove(false);
                    //归档才显示打印和导出按钮
                    // if(ret.PRE_MEETING_STATUS==5){
                    //     this.setState({ isFinished: 'inline' })
                    // }
                }
                else
                { message.error('请先尝试刷新，若仍然加载失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, "药品（剂）使用记录表.xlsx")
    }

    onClickApprove=(appVisible)=>{
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true,key:guid(),param:this.props.data.param,appVisible:appVisible,BtnAgreeDisplay:'inline'},
            formCode: "PF123",
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    render() {
        const { data } = this.state;
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        // let aaa = Math.random();
        return <div>
            <div style={{ padding: '10px' }}>
            <Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px'}} icon="export">审批详情</Button>
                <ReactToPrint
                    trigger={() => <Button style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }} type={'default'} icon={'printer'} >打印</Button>}
                    content={() => this.componentRef}
                />
                <Button onClick={() => this.onTableBtnExport()} icon="export" style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }}>导出</Button>
                <Button type="primary" style={{marginLeft: '8px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >确认</Button>
            </div>
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 style={{ textAlign: 'center', margin: '15px' }}>药品（剂）使用记录表</h1>
                {
                     data ?
                     <div>
                        <Descriptions size="middle" bordered className={stylesStep.description}>
                            <Descriptions.Item label="使用时间">{moment(data.TIME).format('YYYY-MM-DD')}</Descriptions.Item>
                            <Descriptions.Item label="使用部门">{data.Nav_Department ? data.Nav_Department.NAME : ''}</Descriptions.Item>
                            <Descriptions.Item label="使用人员">{
                                data.Nav_Users && data.Nav_Users.map((item, i) => {
                                    if (i == (data.Nav_Users.length - 1)) {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'> {item.Nav_User?.NAME}</label>
                                        else
                                            return item.Nav_User.NAME
                                    } else {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'>{item.Nav_User?.NAME + '  '}</label>
                                        else
                                            return item.Nav_User.NAME + '  '
                                    }
                                })
                            }</Descriptions.Item>
                             <Descriptions.Item label="药品（剂）名称">{data.Nav_Drug ? data.Nav_Drug.NAME : ''}</Descriptions.Item>
                             <Descriptions.Item label="规格">{data.Nav_Specify ? data.Nav_Specify.NAME : ''}</Descriptions.Item>
                             <Descriptions.Item label="使用数量">{data.QTY}</Descriptions.Item>
                             <Descriptions.Item label="单位">{data.UNIT}</Descriptions.Item>
                        </Descriptions>
                     </div>:null
                }
                {
                    data ?  <table style={{ width: '100%', textAlign: 'left'}} className={stylesStep.PrintForm1}>
                    <tr>
                        <td  width='150px' textAlign='center' className={stylesStep.fontBold}>序号</td>
                        <td  className={stylesStep.fontBold}>使用安全确认项目</td>
                        <td  width='150px' className={stylesStep.fontBold}>是否确认</td>
                    </tr>
                    {
                                    data.Nav_Confirms && data.Nav_Confirms.map((item,i)=>{
                                        return <tr>
                                            <td>
                                                {i+1}
                                            </td>
                                            <td>
                                                {item.NAME}
                                            </td>
                                            <td>
                                            {item.IS_CONFIRM == true?"是":"否"}
                                            </td>
                                        </tr>
                                    })
                                }
                    </table>:null 
                }
                {
                     data ?
                     <div>
                        <Descriptions size="middle" bordered className={stylesStep.description}>
                        <Descriptions.Item label='使用人员签名'>
                            <div>{
                                    data.Nav_Users && data.Nav_Users.map((item, i) => {
                                        if (item.DEAL_STATUS == 1) {
                                            if (item.Nav_User != null && item.Nav_User.Nav_UserSignFiles[0] != null)
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} alt={item.Nav_User?.NAME} src={config.picServerHost + item.Nav_User.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                            else
                                                return <img style={{ margin: "0 0 0 15px",width:'150px'  }} title={item.Nav_User?.NAME} />
                                        }
                                    })
                        }</div>
                        </Descriptions.Item>
                        </Descriptions>
                     </div>:null
                }
                <FormPage {...this.state.tmpData} />
            </div>
        </div>
    }

}

export default connect(({ login,app }) => ({ login,app }))(PR050ShowPrint) 